;****************************************************************************
; Filename: FCLOSE.ASM
;   Author: Adam Seychell
;  Version: 0.0
;  Created: 1995.April.29
;  Updated: -
;****************************************************************************
; Copyright Peter Andersson, 1994-1995.
; All rights reserved.
;****************************************************************************
; Function: int @fclose(FILE * file_pointer);
;  Comment: Closes the file stream specified by file_pointer.
;    Input: Eax = file pointer of file to close
;   Output: 0 if successful, otherwise EOF;
;****************************************************************************

		Include STDDEF.INC

		Codeseg
Proc       fclose ,1

		Push    Edi
		Mov     Edi,Eax
		Call    @fflush
		Mov     Eax,[Edi+ FILE._base]
		Cmp     [Edi+ FILE._handle],5		; Don't free a std i/o buffer
		jb @@noFree
		call    @free
@@noFree:
		Mov     Ax,[Edi+ FILE._handle]
		call    @close
		Mov     [Edi+ FILE._mode],00h
		Mov     [Edi+ FILE._handle],-1
		Pop     Edi
		Ret
Endp

		End

