;****************************************************************************
; Filename: FPUTS.ASM
;   Author: Adam Seychell
;  Version: 0.0
;  Created: 1995.April.29
;  Updated: -
;****************************************************************************
; Copyright Peter Andersson, 1994-1995.
; All rights reserved.
;****************************************************************************
; Function: int @fputs(char *s, FILE *stream);
;  Comment: copies the null-terminated string to I/O
;    Input: Eax = source of string
;			Edx = pointer of FILE stream
;   Output: Eax = pointer of string, of EOF on error;
;****************************************************************************

		Include STDDEF.INC

		Codeseg

Proc fputs , 2
		Push	Ebx
		Push	Eax
		Push	Edx
		Call	@strlen
		Mov		Ecx,Eax
		Pop		Edx
		Pop		Eax
		Mov		Ebx,Eax
		Push	Ecx
		Push	Edx
		Mov		Edx,1
		call	@fwrite
		add		Esp,4
		Pop		Ecx
		Cmp     Ecx,Eax
		jne @@error
		Movzx	Eax,[Byte ptr Ebx+Ecx-1]
		Pop		Ebx
		Ret

@@error:
		Mov		Eax,EOF
		Pop		Ebx
		Ret
Endp
		End
