;******************************************************************************
; Filename: STRDUP.ASM
;   Author: Peter Andersson
;  Version: 0.0
;  Created: 1995.03.12
;  Updated: 
;******************************************************************************
; Copyright Peter Andersson, 1994-1995.
; All rights reserved.
;******************************************************************************
; Function: PSZ @strdup(PSZ str)
;  Comment: Duplicates a string
;  Returns: Pointer to the duplicated string or null if out of memory
;******************************************************************************

        Include STDDEF.INC

        Codeseg

Proc    strdup  ,1
                Push    Eax
                Call    @strlen
                Inc     Eax
                Call    @malloc
                TestZ   Eax
                Jz      @@Exit01
                Pop     Edx
                Call    @strcpy
@@Exit01:       Ret
Endp

        End
