;******************************************************************************
; Filename: STRUPR.ASM
;   Author: Peter Andersson
;  Version: 0.0
;  Created: 1995.03.12
;  Updated: 
;******************************************************************************
; Copyright Peter Andersson, 1994-1995.
; All rights reserved.
;******************************************************************************
; Function: PSZ @strupr(PSZ str)
;  Comment: Converts a string to uppercase.
;    Input: Eax - string pointer
;  Returns: str
;******************************************************************************

        Include STDDEF.INC

        Codeseg

Proc    strupr  ,1
                Mov     Edx,Eax
                Clear   Ecx
        Align   4
@@Loop:         Mov     Cl,[Eax]
                Mov     Cl,[Ecx+UpperCaseTable]
                Mov     [Eax],Cl
                Inc     Eax
                TestZ   Cl
                Jnz     @@Loop
                Mov     Eax,Edx
                Ret
Endp

        Dataseg

                Include "UPCASE.INC"

        End
