;******************************************************************************
; Filename: TLOWER.ASM
;   Author: Peter Andersson
;  Version: 0.0
;  Created: 1995.03.12
;  Updated: 
;******************************************************************************
; Copyright Peter Andersson, 1994-1995.
; All rights reserved.
;******************************************************************************
; Function: int @tolower(char chr)
;  Comment: Converts a character to ulowercase.
;    Input: Al - character
;  Returns: unsigned character value
;******************************************************************************

        Include STDDEF.INC

Extrn  LowerCaseTable :Byte

        Codeseg

Proc    tolower ,1
                Movzx   Eax,Al
                Movzx   Eax,[LowerCaseTable+Eax]
                Ret
Endp



        End
