;****************************************************************************
; Filename: SETVECT.ASM
;   Author: Peter Andersson
;  Version: 0.0
;  Created: 1995.03.13
;  Updated: -
;****************************************************************************
; Copyright Peter Andersson, 1994-1995.
; All rights reserved.
;****************************************************************************
; Function: VOID @setvect(ULONG i,PIRQVECT v);
;  Comment: Sets a interrupt vector
;    Input: Eax,i - interrupt number (0-255)
;           Edx,v - pointer to new IRQVECT, interrupt vector
;   Output: nothing
;****************************************************************************

        Include STDDEF.INC

        Codeseg

Proc    setvect ,2
                Mov     Bl,Al
                Mov     Ax,205h
                Mov     Cx,[Edx+4]
                Mov     Edx,[Edx]
                Int     31h
                Ret
Endp

        End
