;****************************************************************************
; Filename: _EXIT.ASM
;   Author: Peter Andersson
;  Version: 0.0
;  Created: 1995.03.31
;  Updated: -
;****************************************************************************
; Copyright Peter Andersson, 1994-1995.
; All rights reserved.
;****************************************************************************
; Function: VOID @_exit(ULONG errorlevel);
;  Comment: Exits your program with an errorlevel and does not flush any
;           buffers or executes any registered atexit functions.
;    Input: Eax, errorlevel - errorlevel returned to the system. Should be
;           between 0 and 255.
;   Output: nothing
;****************************************************************************

        Include STDDEF.INC

        Codeseg

Extrn AbortStackPos:Dword
Extrn NoLanguage ExitQuick:Near

Proc    _exit   ,1
                Mov     Esp,[AbortStackPos]             ; Load startup stack
                Jmp     ExitQuick                       ; Exit quickly
Endp

        End
