#include <stdio.h>
#include <stdlib.h>
#include "jlvesa.h"

JVFont *jlfont_font;

void JVFont_Select(JVFont *font)
{
   jlfont_font=font;
}

void JVText_Draw(int x,int y,char *string)
{
   int character,pointer=0,tx;
   JVUWord offset;

   tx=x;
   while((character=*(string+pointer++))!=0)
   {
      offset=jlfont_font->offset[character];
      if(offset!=0xFFFFu)
      {
         JVImage_DrawOn(tx,y,*(jlfont_font->font_data+offset),
                        jlfont_font->height,
                        jlfont_font->font_data+offset+1);
         tx+=*(jlfont_font->font_data+offset);
      }
      else
         tx+=jlfont_font->width;
   }
}
