// MOUSE handling functions

struct State {
              unsigned PointX, PointY, Button, EventX, EventY;
              unsigned char Cursor;
             };

#ifdef __cplusplus
 extern "C" {
#endif

            extern struct State Mouse;
            extern unsigned resetmouse();
            extern void setlocation(unsigned,unsigned);
            extern void defrange(unsigned,unsigned,unsigned);
            extern void Install_mouse();
            extern void SetDrawProc( void (*)() );
            extern void mouse_cursor(unsigned);

#ifdef __cplusplus
           }
#endif

#define set_Xrange(xmin,xmax) defrange(7, xmin, xmax)
#define set_Yrange(ymin,ymax) defrange(8, ymin, ymax)

#define ON       0x0001
#define OFF      0x0000

#define LEFT_BUTTON     0x0001
#define RIGHT_BUTTON    0x0002
#define CENTER_BUTTON   0x0004

