;Ŀ
;         MASM   reg2asc  12-22-1995              
;

;     Robert F. Wolf - CompuServe 74407,1426


 code  segment
;
 Angie_for_ever  proc  far      ;main proc 
;
;-
        assume  cs:code
        org     100h            ;com program works with (EXE2BIN)
;
 start:                    
        mov     ah,02h          ;Set screen mode(25x80 B&W)     
        mov     al,0            
        int     10h

        call    cls             ;Call cls proc
 
        call    cursoff         ;Call cursor off proc
        
        mov     ax,00h          ;Reset mouse (hardware)
        int     33h             ;     and check
        cmp     ax,0            ;  0 in ax = No Mouse
        jne     exists          ;Mouse installed goto exists

        mov     dx,offset not_installed
        mov     ah,09h          ;Display Mouse Not Installed 
        int     21h             ;        message and
        jmp     exit            ;           Exit

 exists:
        mov     dl,18           ;Set cursor position
        mov     dh,1            ;  DH-row, DL-col
        call    locate          ;Call locate proc
        
        mov     dx,offset installed
        mov     ah,09h
        int     21h

        mov     ax,1            ;Mouse on
        int     33h

 Angel_1_20:   
        mov     dh,23           ;Set cursor position
        mov     dl,60           ;  DH-row, DL-col
        call    locate          ;Call locate proc

        mov     ax,3            ;Mouse info on        
        int     33h

        push    bx              ;Save button
        push    cx              ;Save cx coord.
        mov     cx,dx           ;Do dx first

        call    div_8           ;Convert dx to
        call    ascii           ; ASCII proc

        mov     dl,' '          ;Add (2) spaces
        mov     ah,2            ;DOS display character
        int     21h             ;Call DOS             
        mov     dl,' '
        mov     ah,2            ;DOS display character
        int     21h             ;Call DOS
             
        pop     cx              ;Pop saved cx

        call    div_8           ;Convert cx to        
        call    ascii           ; ASCII proc

        pop     bx              ;Check for right button
        cmp     bx,2
        je      snow_hug        ;If right press - snow_hug
                                ;         or  
        jmp     Angel_1_20      ;   Goto Angel_1_20    

 snow_hug:
        mov     ax,2            ;Turn mouse off
        int     33h

        call    cls             ;Clear screen

 exit:
        call    curson          ;Call cursor on proc
        int     20h             ;Return to DOS

;----------------------------------------------
 not_installed  db      'Mouse not installed... $'
 installed      db      'Mouse Coordinates - Right button to Exit$'
;----------------------------------------------
;
 Angie_for_ever   endp          ;main proc end   
;
;Ŀ
;  S U B R O U T I N E S  
;
;---------------------------------------
div_8   proc    near            ;Divide by 8 for 25x80 text mode...
        mov     ax,cx           ;Move CX to AX for div
        cwd                     ;Convert for div
        mov     cx,8            ;Use CX for 8
        div     cx              ;AX / CX = AL rDX
        cwd                     ;Convert AL[8bit] to AX[16bit]
        mov     cx,ax           ;Put AX in CX
        ret                     ;Proc done... return
div_8   endp
;---------------------------------------

;------------------------------------------------------------------------
 ascii  proc    near            ;Binary to digits (huns|tens|ones)
        mov     bx,cx           ;Put cx in bx 
        mov     cx,100          ;Coordinate/100
        call    dec_div         ;call to div by cx
        mov     cx,10           ;Remainder/10
        call    dec_div         ;call to div by cx
        mov     cx,1            ;Remainder/1
        call    dec_div         ;call to div by cx
        ret                     ;Proc done... return
 ascii  endp
;--------------------------
dec_div proc    near            ;Do division 
        mov     ax,bx           ;Put BX in AX for div
        cwd                     ;Convert for div
        div     cx              ;AX / CX = AL rDX
        mov     bx,dx           ;Put remainder in BX for next digit
        mov     dl,al           ;Separated digit in DL
        call    tty             ;Call to display DL
        ret                     ;Proc done... return
dec_div endp
;--------------------------
tty     proc    near
        add     dl,30h          ;Add 30h to DL for ascii  
        mov     ah,2            ;DOS display character and adv. cursor
        int     21h             ;Call DOS
        ret                     ;Proc done... return 
tty     endp        
;------------------------------------------------------------------------

;---------------------------------------

locate  proc    near            ;Cursor locate proc
        mov     ah,2            ;Note: put DH=(row), DL=(col)  
        int     10h             ;        before making call 
        ret                     ;Proc done... return
locate  endp
;---------------------------------------
cls       proc  near            ;Cls proc
          mov   ah,6
          mov   al,0
          mov   ch,0
          mov   cl,0
          mov   dh,24
          mov   dl,79
          mov   bh,7
          int   10h
          ret                   ;Proc done... return
cls       endp 
;---------------------------------------
curson  proc    near            ;Turn cursor on 
        mov     ax,256
        mov     cx,0607h
        int     10h
        ret                     ;Proc done... return
curson  endp
;---------------------------------------
cursoff proc    near            ;Turn cursor off
        mov     ax,256
        mov     cx,0f00h
        int     10h
        ret                     ;Proc done... return
cursoff endp
;---------------------------------------
 code  ends
       end     start

        

     

         
















