/*
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/

#include "..\jlib.h"
#include "..\memcopy.h"

/*+------------------------------------------------------------------------+*/
/*|blit a fullscreen buffer to the screen                                  |*/
/*+------------------------------------------------------------------------+*/
/*|this routine is just a normal blit that assumes a width of 320 and a    |*/
/*|height of 200.                                                          |*/
/*+------------------------------------------------------------------------+*/

#undef LIBDEBUG
#ifdef __DEBUG_screen_blit_fs_buff
 #include <stdio.h>
 #define LIBDEBUG(x) x;fflush(stdout)
#else
 #define LIBDEBUG(x)
#endif

inline void screen_blit_fs_buff(buffer_rec *buff,USHORT x, USHORT y)
/* NOTE: buffer must be word aligned and the same width as the screen!*/
{
 UBYTE *screen=SCREEN_START;
 UBYTE *obuff;

 LIBDEBUG(printf("\nEntering screen_blit_fs_buff()\n\n"));

 obuff=(buff->buffer)+((y*B_X_SIZE(buff))+x);

  WORD_COPY(obuff,screen,64000);


 LIBDEBUG(printf("\nLeaving screen_blit_fs_buff()\n\n"));
}
