/* strippal.c - strip the pallete out of a 256 color PCX file
**
** Copyright (C) 1995  Jonathan Paul Griffiths.  All rights reserved.
**
** You may do anything with this code you wish EXCEPT sell it. You may sell
** any software you create using this code,  but you MUST NOT charge for
** the code itself.  Charging a distribution fee for this code is also
** FORBIDDEN.
*/
/* 
** This program does exactly what it says and nothing more.
*/

#include <stdio.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
  FILE *fp,*new;
  unsigned char s[768];

  if(argc!=3){
	      printf("strippal - strip the palette of a .pcx into a seperate file.\n");
	      printf("Usage: strippal <infile> <outfile> \n");
	      printf("Where: <infile>  = .pcx file to get palette from.\n");
	      printf("Where: <outfile> = file to put palette into.\n");
	      exit(-1);
  }

  if((fp=fopen(argv[1],"rb"))==NULL){
     printf(" ERROR: Could not open file %s for reading.",argv[1]);
     exit(-1);
  }

  if((new=fopen(argv[2],"wb"))==NULL){
     printf(" ERROR: Could not open file %s for writing.",argv[2]);
     exit(-1);
  }

  fseek(fp,-768,SEEK_END);

  fread(s,768,1,fp);

  fwrite(s,768,1,new);

  fclose(fp);
  fclose(new);

  return(0);
}
