// cvtname.cpp : implementation file
//

#include "stdafx.h"
#include "win95dlg.h"
#include "cvtname.h"      
#include "dadlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ConvertNameDlg dialog


ConvertNameDlg::ConvertNameDlg(CWnd* pParent /*=NULL*/)
	: CDialog(ConvertNameDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ConvertNameDlg)
	m_name = "";
	//}}AFX_DATA_INIT
}

void ConvertNameDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ConvertNameDlg)
	DDX_Text(pDX, IDC_EDIT1, m_name);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(ConvertNameDlg, CDialog)
	//{{AFX_MSG_MAP(ConvertNameDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// ConvertNameDlg message handlers

void ConvertNameDlg::OnOK()
{
	UpdateData();   
    char lpszLongName[256]; 
    lstrcpy(lpszLongName, m_name);
	
	GetWin95ShortPathName(m_hWnd, lpszLongName, sizeof(lpszLongName));
	CString str("The file's short name is:\n\n");
	str += lpszLongName;
	
	MessageBox(str);
	
	CDialog::OnOK();
}

void ConvertNameDlg::OnButton1()
{
	CreateWin95FileDlg(TRUE, // TRUE if File Open, otherwise FALSE
	                   "", // default extension 
	                   "", // initial filename that appears in the filename edit box. If NULL, no filename initially appears
	                   OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, // file open flags 
	                                                           // see the OPENFILENAME structure description in the Windows SDK documentation
					   "All Files (*.*) | *.*||", // A series of string pairs that specify filters you can apply to the file
	                   m_hWnd); // handle to the file dialog-box object's parent or owner window

    SetWin95DlgTitle("Find a file to convert it's long file name to short file name");
    
    Win95DlgDoModal(m_hWnd);
    
    char lpszLongName[256];
    
    GetWin95LongFilePath(lpszLongName, sizeof(lpszLongName));
    
    m_name = lpszLongName;
    UpdateData(FALSE);
}
