/*
	This file is supposed to implement the
	asm crap the MS sent along with its WinToon
	SDK.
*/
#include <windows.h>
#include <windowsx.h>
#include "dibstuff.h"
#include "dibasm.h"

//#define MK_FP(seg,ofs) ((void __seg *)(seg) + (void __huge *)(ofs))
#define MK_FP(seg,ofs) ((void __seg *)(seg) + (void __near *)(ofs))

void PASCAL far
Copy32Bytes( WORD DestSelector, DWORD DestOffset, WORD SrcSelector,
													DWORD SrcOffset, DWORD cBytes)
{
	unsigned char huge *dest1;
	unsigned char huge *source1;
	unsigned long huge *dest2;
	unsigned long huge *source2;
	unsigned long countBy4;
	unsigned long rem, i;
	unsigned long count;

	dest1 = (unsigned char huge *)MK_FP( DestSelector, 0L);
	dest1 += DestOffset;
	source1 = (unsigned char huge *)MK_FP( SrcSelector, 0L);
	source1 += SrcOffset;
	dest2 = (unsigned long huge *)dest1;
	source2 = (unsigned long huge *)source1;

	countBy4 = cBytes/4L;
	rem = cBytes % 4L;
	for (count = 0; count < countBy4; count ++)
		dest2[count] = source2[count];

	for (i = 1; i<=rem; i++)
		dest1[cBytes - i] = source1[cBytes - i];

}



void FAR PASCAL
CopyTransparentBits(WORD selDst, DWORD offDst, DWORD pitchDst,
							WORD selSrc, DWORD offSrc, DWORD pitchSrc,
							DWORD cx, DWORD cy, BYTE transparent)
{
	unsigned char huge *dest;
	unsigned char huge *source;
	unsigned long i;
	unsigned long count;

	dest = (unsigned char huge *)MK_FP( selDst, 0L);
	dest += offDst;
	source = (unsigned char huge *)MK_FP( selSrc, 0L);
   source += offSrc;

	count = cy; /* i.e. the number of lines to copy...*/

	while (count)
	{
		for(i = 0; i<cx ; i++)
			if( source[i] != transparent)
				dest[i] = source[i];

		dest += pitchDst;
		source += pitchSrc;
		count--;
	}

}



void CopyBytes(LPBYTE pDst, LPBYTE pSrc, DWORD cb)
{
	WORD DestSelector = HIWORD (pDst);
	DWORD DestOffset = LOWORD (pDst);
	WORD SourceSelector = HIWORD (pSrc);
	DWORD SourceOffset = LOWORD (pSrc);

	Copy32Bytes (DestSelector, DestOffset, SourceSelector, SourceOffset, cb);
}





