//****************************************************************************
// File:
//
//     DLGBOX1.H
//
// Purpose:
//
//     Provides the declaration for the CDialogBox1 class.
//
// Development Team:
//
//     Joel Krist
//
//     Modified:
//
//     James Rhodes - added support for new Win32 WM_HELP & WM_CONTEXTMENU
//                    messages.
//
// Written by Microsoft Product Support Services, Languages Developer Support
// Copyright (c) 1993, 1995 Microsoft Corporation. All rights reserved.
//****************************************************************************

class CDialogBox1 : public CDialog
{
// Construction
public:
    CDialogBox1(CWnd* pParent = NULL);    // standard constructor

// Dialog Data
    //{{AFX_DATA(CDialogBox1)
    enum { IDD = IDD_DIALOGBOX1 };
        // NOTE: the ClassWizard will add data members here
    //}}AFX_DATA

// Implementation
protected:
	static DWORD m_dwHelpMap[];
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

    // Generated message map functions
    //{{AFX_MSG(CDialogBox1)
    virtual BOOL OnInitDialog();
	//}}AFX_MSG

	// Windows 95 style popup help if using MFC 4.0
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);

    DECLARE_MESSAGE_MAP()
};
