;****************************************************************************
; Filename: PRINTF.ASM
;   Author: Peter Andersson
;  Version: 0.0
;  Created: 1995.02.09
;  Updated: -
;****************************************************************************
; Copyright Peter Andersson, 1994-1995.
; All rights reserved.
;****************************************************************************
; Function: ULONG printf(PSZ fmtstr,...);
;    Input: fmtstr - printf format string
;           ... - possible arguments
;   Output: Number of characters written
;  Comment: Prints a formatted string to stdout and returns the number of
;           written characters.
;****************************************************************************

        Include STDDEF.INC

        Codeseg

Proc    printf
        Pop  [Eip_save]
        push stdout
        call fprintf
        add  esp,4
        jmp  [Eip_save]

    Align 4
Eip_save DD ?

Endp

        End
