// Each menu must have items, hotkey definitions and messages.  All arrays //
// must have the same # of elements, and must end with NULL as shown. //
// The menus are fully automatic.  They size and position themselves. //
// Ensure total length of main menu bar does not exceed 80 characters. //
// To check the total size, use the calculation shown in the INT.CPP file //
// under the size_error function.  Size will be checked automatically if //
// you don't want to mess with it.  Create pulldowns with up to 21 rows. //
// Main menu array must be named mainmenu, mainkeys, and mainmsgs. //
// Pulldowns can have any name.  Use the same names when called in main(). //
// Easy! Easy! Easy!  You just define them as below, and the User Interface //
// takes care of everything else.  Examine the main() function in INT.CPP //
// to see just how simple it is to call your functions after the selection //
// is returned from the pulldown menus.  The windowing library also has //
// just about any feature you may need for text window display functions. //
// Also included is my free text file viewer (up to 600k) and source code //
// Also included is a modified Borland mouse handler.  Simple and good! //
// Enjoy!  Jay Lewis, 102365,3264 at Compuserve.  Please write. //

char *mainmenu[]   = {"Number1","nUmber2","nuMber3","Shell","Quit","Help",NULL};
int   mainkeys[]   = {0,1,2,0,0,0,NULL};
char *mainmsgs[]   = {"Choose from first, second, or third items",
		      "One item on this menu",
		      "Two items on this menu",
		      "Shell to DOS",
		      "Quit program, Do not quit",
		      "Show the menu definition file, Display program and version information",
		      NULL};

char *pull0items[] = {"First choice","Second choice","Third choice","fOurth choice","fIfth choice","siXth choice","sEventh choice",NULL};
int    pull0keys[] = {0,0,0,1,1,2,1,NULL};
char  *pull0msgs[] = {"This is the first pulldown menu choice",
		      "This is the second pulldown menu choice",
		      "This is the third pulldown menu choice",
		      "This is the fourth pulldown menu choice",
		      "This is the fifth pulldown menu choice",
		      "This is the sixth pulldown menu choice",
		      "This is the seventh pulldown choice, up to 21 allowed",
		      NULL};

char *pull1items[] = {"Only choice",NULL};
int    pull1keys[] = {0,NULL};
char  *pull1msgs[] = {"This is the only pulldown menu choice",
		      NULL};

char *pull2items[] = {"First choice","Second choice",NULL};
int    pull2keys[] = {0,0,NULL};
char  *pull2msgs[] = {"This is the first pulldown menu choice",
		      "This is the second pulldown menu choice",
		      NULL};

char *pull3items[] = {"Shell to DOS",NULL};
int    pull3keys[] = {0,NULL};
char  *pull3msgs[] = {"Shell to the operating system",
		      NULL};

char *pull4items[] = {"Yes","No",NULL};
int    pull4keys[] = {0,0,NULL};
char  *pull4msgs[] = {"Quit the program",
		      "Resume work in the program",
		      NULL};

// Automatically moves pulldown if length of item puts the pulldown //
// past the right border.  Observe this feature in demo program //
char *pull5items[] = {"Display INT.H include file used to create this demo","About User Interface",NULL};
int    pull5keys[] = {0,0,NULL};
char  *pull5msgs[] = {"Display menu definition file included to create this example",
		      "Display program and version information",
		      NULL};
