// This file is part of JLVesa-library

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include "jlvesa.h"

extern JVFont *jlfont_font;

// void vesa_get_text(int x,int y,char *string,int maxlength,unsigned char fgcolor,
//                    unsigned char bgcolor)
//
// Read/edit string keyboard.

void JVText_Input(int x,int y,char *string,int maxlength,
                  unsigned char fgcolor,unsigned char bgcolor)
{
   int length,glength;
   int a;

   // Put string to the screen

   string[maxlength-1]=0;
   JVText_Draw(x,y,string);

   // Put cursor after string

   length=strlen(string);
   glength=JVText_GetLength(string);
   JVRectangle_Draw(x+glength,y,jlfont_font->width,jlfont_font->height,fgcolor);

   // Wait for keystrokes

   while(1)
   {
      a=getch();

      // Special character

      if(a==0)
         getch();

      // Return

      else if(a==13)
         return;

      // Character

      else if(a>31)
      {
         if(length<maxlength-1)
         {
            string[length++]=a;
            string[length]=0;
            JVRectangle_Draw(x+glength,y,jlfont_font->width,
                             jlfont_font->height,bgcolor);
            JVText_Draw(x+glength,y,string+length-1);
            glength=JVText_GetLength(string);
            JVRectangle_Draw(x+glength,y,jlfont_font->width,
                             jlfont_font->height,fgcolor);
         }
         else
         {
            putchar(7);
         }
      }

      // Backspace

      else if(a==8)
      {
         if(length>0)
         {
            string[--length]=0;
            JVRectangle_Draw(x+glength,y,jlfont_font->width,
                             jlfont_font->height,bgcolor);
            glength=JVText_GetLength(string);
            JVRectangle_Draw(x+glength,y,jlfont_font->width,
                             jlfont_font->height,fgcolor);
         }
         else
         {
            putchar(7);
         }
      }
   }
}
