; This routine is part of VESA SVGA -library

model large,c
p386

segment jlvesa00_TEXT USE16 'CODE'
assume cs:jlvesa00_TEXT

; JVFlag JVSVGA_GetInfo(JVSVGAInfo *info)
;
; Get information of current VESA-card. Returns 0 if successful, 1 if failed

proc JVSVGA_GetInfo far
   public JVSVGA_GetInfo

   push  bp
   push  di
   push  es

   mov   bp,sp                ; ES:DI = pointer to svga_info -table
   mov   di,[ss:bp+10]
   mov   es,[ss:bp+12]
   mov   ax,4f00H             ; Call VESA-interrupt
   int   10H

   cmp   ax,4fH               ; Check if function was succesfull
   je    short supported
   mov   ah,1
supported:

   pop   es
   pop   di
   pop   bp
   mov   al,ah

   retf
endp JVSVGA_GetInfo

ends

end
