; This routine is part of VESA SVGA -library
;
; Copyright 1994 Johannes Lehtinen
; All rights reserved

model large,c
p386

segment jlvesa01_TEXT USE16 'CODE'
assume cs:jlvesa01_TEXT

; JVFlag JVSVGA_GetModeInfo(JVUWord mode, JVModeInfo *info)
;
; Get information of VESA-mode. Returns 0 if succesfull, 1 if failed

proc JVSVGA_GetModeInfo far
   public JVSVGA_GetModeInfo

   push  bp
   push  di
   push  es

   ; Call VESA function

   mov   bp,sp
   mov   cx,[ss:bp+10]        ; CX = Mode
   mov   di,[ss:bp+12]        ; ES:DI = Pointer to information
   mov   ax,[ss:bp+14]
   mov   es,ax
   mov   ax,4f01H             ; AX = Function number
   int   10H                  ; Call VESA function

   ; Check if everything was succesfull

   cmp   ax,4fH               ; AX should be 4fH if succesfull
   je    short no_error       ; Succesfull

   mov   ah,1                 ; Error -> return 1

   ; Return

no_error:
   pop   es
   pop   di
   pop   bp
   mov   al,ah
   retf

endp JVSVGA_GetModeInfo

ends

end
