; This routine is part of the VESA SVGA -library
;
; Copyright 1994 Johannes Lehtinen
; All rights reserved

model large,c
p386

segment jlvesa03_TEXT USE16 'CODE'
assume cs:jlvesa03_TEXT

; JVFlag JVScreen_SetVisual(JVUWord pixel, JVUWord line)
;
; Set start of the visual display. Pixel is the first displayed pixel and
; line is the first displayed line. Returns 0 if succesfull, 1 if not.

proc JVScreen_SetVisual far
   public JVScreen_SetVisual

   push  bp
   mov   bp,sp

   mov   ax,4f07H             ; Set display start -function
   mov   bx,0
   mov   cx,[ss:bp+6]         ; CX = First pixel
   mov   dx,[ss:bp+8]         ; DX = First line
   int   10H                  ; Call VESA BIOS

   cmp   ax,4fh               ; Check if succesfull
   jne   short fail

   mov   al,0
   pop   bp
   retf

fail:
   mov   al,1
   pop   bp
   retf

endp JVScreen_SetVisual

ends

end
