; This routine is part of VESA SVGA -library
;
; Copyright 1994 Johannes Lehtinen
; All rights reserved

model large,c
p386

segment jlvesa13_TEXT USE16 'CODE'
assume cs:jlvesa13_TEXT

; void JVPalette_Set(JVPalette palette)
;
; Function sets palette

proc JVPalette_Set far
   public JVPalette_Set

   push  bp
   mov   bp,sp
   push  si
   push  ds

   lds   si,[ss:bp+6]         ; Load address of palette
   cld                        ; Direction forward

   ; Set palette

   mov   dx,3c8H
   mov   al,0
   out   dx,al

   mov   dx,3c9H
   mov   cx,3*256

   rep   outsb

   pop   ds
   pop   si
   pop   bp
   retf

endp JVPalette_Set

ends

end

