; This file is part of the source code of VESA SVGA -library
;
; Copyright 1994 Johannes Lehtinen
; All rights reserved

; Global data segment for library

segment JLVesa_Data common USE16 'DATA'

   Width             dw    ?  ; Width in pixels
   Height            dw    ?  ; Height in pixels
   LWidth            dw    ?  ; Logical width in pixels
   Size              dd    ?  ; Size of the video memory
   PSize             dd    ?  ; Size of video page
   WSize             dd    ?  ; Window size
   Granularity       dd    ?  ; Window granularity
   WWSeg             dw    ?  ; Write window start segment
   RWSeg             dw    ?  ; Read window start segment
   RAStart           dd    ?  ; Current start address of active window (read)
   WAStart           dd    ?  ; Current start address of active window (write)
   AStart            dd    ?  ; Current start address of active page
   VStart            dd    ?  ; Current start address of visual page
   PosFunc           dd    ?  ; Window positioning function
   Pages             db    ?  ; Number of video pages
   RWin              db    ?  ; Number of read window
   WWin              db    ?  ; Number of write window

ends
