// -------------------------------------------------
// TILE LAYER v1.0
// (c) 1995 Copyright NikSoft International
// -------------------------------------------------

// Classi di utilita' generica
// -------------------------------------------------

// definizione costanti per le options di message_window
#define WNDW_DEF         0x0000     // non aspetta una risposta
#define WNDW_REP         0x0001     // aspetta una risposta si'/no
#define WNDW_CNT         0x0002     // Centra la finestra

// -------------------------------------------------

class Window {
protected:
 unsigned win_x, win_y, Xsize, Ysize;
 char far *save_buffer;
 char *title;

public:
 Window(unsigned, unsigned, unsigned, unsigned, char *);
 virtual ~Window();

 virtual void draw();
};

class input_Window: public Window {
 char *prompt;
 unsigned buffer_size, input_size;
 unsigned start_input_x, start_input_y;

public:
 input_Window(unsigned, unsigned, char *, unsigned);

 char *do_input();  // restituisce la stringa letta

 virtual void draw();
};

class message_Window: public Window {
 char *message;
 unsigned options;

public:
 message_Window(unsigned, unsigned, unsigned, char *);
 int show_mes();

 virtual void draw();
};