Option Explicit
DefInt A-Z
Type DILIndexType
 Name         As String * 32
 Offset       As Long
 StoredLength As Long
 RealLength   As Long
 Compression  As Integer
 spare1       As Integer
 XPixels      As Long
 YPixels      As Long
 spare2       As Long
 spare3       As Long
End Type
Declare Function imOpenDIL% Lib "T4IMAGES.DLL" (ByVal libname$)
'/*******************************************/
'/* return  1-99 library file handle        */
'/* return -1 invalid file name             */
'/* return -2 file-open error               */
'/* return -3 not a T4DIBLIB file           */
'/* return -4 not enough memory             */
'/* return -5 too many open libraries       */
'/*******************************************/
Declare Function imGetDILMemberInfo% Lib "T4IMAGES.DLL" (ByVal hDIL%, ByVal memname$, x As DILIndexType)
'/******************************************/
'/* return 0 returned info valid           */
'/* return 1 invalid member name           */
'/* return 2 member not found              */
'/******************************************/
Declare Function imDILMemberCount% Lib "T4IMAGES.DLL" (ByVal hDIL%)
Declare Sub imGetDILIndex Lib "T4IMAGES.DLL" (ByVal hDIL%, x As DILIndexType)
Declare Function imLoadDILMember% Lib "T4IMAGES.DLL" (ByVal hDIL%, ByVal memname$, ByVal rsvd%)
'/******************************************/
'/* return >=32 hDIB                       */
'/* return 1 invalid member name           */
'/* return 2 member not found              */
'/* return 3 not enough memory             */
'/* return 4 disk read error               */
'/* return 5 internal error                */
'/******************************************/
Declare Sub imCloseDIL Lib "T4IMAGES.DLL" (ByVal hDIL%)
' Utility Memory Routines
Declare Function imLockDIB& Lib "T4IMAGES.DLL" (ByVal hDIB%)
Declare Sub imFreeDIB Lib "T4IMAGES.DLL" (ByVal hDIB%)


