***
*   Langage : Clipper 5.0 VF
*   Auteur  : Philippe Bonnardel
*
* My Address: 27, Bd de VERDUN - 92400 COURBEVOIE - FRANCE
*
*   Version : 1.0 - FREEWARE
*
*   Date    : 10/06/94
*   Objet   : Dterminer la prsence ou non du driver EMM386.EXE en mmoire
*           : et dtecter le commutateur 'NOEMS' responsable d'un 'BUG'
*           : des applications crites en Clipper 5.0 et 5.01 sous DOS 6.x.
*   Compil  : /M/L/N/W
*   Liens   : voir (see) ems.prg
***

#include "ems.ch"

FUNCTION MAIN()
LOCAL nRet := EMS()
IF nRet == NOEMS
  ? "Problme avec le gestionnaire de mmoire pagine 'EMM386.EXE'..."
  ? "Enlever son paramtre 'NOEMS' !" 
  ? "- FIN DU PROGRAMME -"
  ?
  ? "Problem with the program 'EMM386.EXE'..."
  ? "To get rid of its 'NOEMS' parameter"
  ? "- QUIT -"
  ?
  QUIT
ELSEIF nRet == NO_EMM
  ? "Gestionnaire de mmoire pagine non prsent en mmoire..."
  ?
  ? "'EMM386.EXE' isn't in memory..."
  ?
ELSEIF nRet == OK_EMM
  ? "Gestionnaire de mmoire pagine charg en mmoire..."
  ?
  ? "'EMM386.EXE' is in memory..."
  ?
ELSEIF nRet == NOEMS_NOVCPI
  ? "Gestionnaire de mmoire pagine charg en mmoire..."
  ? "Paramtre 'NOVCPI'"
  ?
  ? "'EMM386.EXE' is in memory..."
  ? "'NOVCPI' parameter"
  ?
ENDIF
RETURN(NIL)

